---
references:
- id: BlazekDeep2021
  accessed:
    - year: 2022
      month: 2
      day: 18
  author:
    - family: Blazek
      given: Paul J.
    - family: Venkatesh
      given: Kesavan
    - family: Lin
      given: Milo M.
  citation-key: BlazekDeep2021
  container-title: arXiv:2111.08275 [cs]
  issued:
    - year: 2021
      month: 11
      day: 16
  title: 'Deep Distilling: automated code generation using explainable deep learning'
  type: article-journal
  URL: http://arxiv.org/abs/2111.08275

- id: BlazekExplainable2021
  accessed:
    - year: 2022
      month: 2
      day: 18
  author:
    - family: Blazek
      given: Paul J.
    - family: Lin
      given: Milo M.
  citation-key: BlazekExplainable2021
  container-title: Nature Computational Science
  container-title-short: Nat Comput Sci
  DOI: 10.1038/s43588-021-00132-w
  ISSN: 2662-8457
  issue: '9'
  issued:
    - year: 2021
      month: 9
  language: en
  number: '9'
  page: 607-618
  publisher: Nature Publishing Group
  title: Explainable neural networks that simulate reasoning
  type: article-journal
  volume: '1'

- id: BlazekNeural2020
  accessed:
    - year: 2020
      month: 6
      day: 5
  author:
    - family: Blazek
      given: Paul J.
    - family: Lin
      given: Milo M.
  citation-key: BlazekNeural2020
  container-title: arXiv:2002.11319 [cs, q-bio]
  issued:
    - year: 2020
      month: 2
      day: 26
  title: A neural network model of perception and reasoning
  type: article-journal
  URL: http://arxiv.org/abs/2002.11319

- id: BottouMachine2011
  accessed:
    - year: 2015
      month: 1
      day: 21
  author:
    - family: Bottou
      given: Leon
  citation-key: BottouMachine2011
  container-title: arXiv:1102.1808 [cs]
  issued:
    - year: 2011
      month: 2
      day: 9
  title: From Machine Learning to Machine Reasoning
  type: article-journal
  URL: http://arxiv.org/abs/1102.1808

- id: BubeckSparks2023
  accessed:
    - year: 2023
      month: 3
      day: 28
  author:
    - family: Bubeck
      given: Sébastien
    - family: Chandrasekaran
      given: Varun
    - family: Eldan
      given: Ronen
    - family: Gehrke
      given: Johannes
    - family: Horvitz
      given: Eric
    - family: Kamar
      given: Ece
    - family: Lee
      given: Peter
    - family: Lee
      given: Yin Tat
    - family: Li
      given: Yuanzhi
    - family: Lundberg
      given: Scott
    - family: Nori
      given: Harsha
    - family: Palangi
      given: Hamid
    - family: Ribeiro
      given: Marco Tulio
    - family: Zhang
      given: Yi
  citation-key: BubeckSparks2023
  DOI: 10.48550/arXiv.2303.12712
  issued:
    - year: 2023
      month: 3
      day: 24
  number: arXiv:2303.12712
  publisher: arXiv
  title: 'Sparks of Artificial General Intelligence: Early experiments with GPT-4'
  type: article
  URL: http://arxiv.org/abs/2303.12712

- id: ClarkTransformers2020
  accessed:
    - year: 2020
      month: 6
      day: 5
  author:
    - family: Clark
      given: Peter
    - family: Tafjord
      given: Oyvind
    - family: Richardson
      given: Kyle
  citation-key: ClarkTransformers2020
  container-title: IJCAI 2020
  issued:
    - year: 2020
      month: 5
      day: 5
  title: Transformers as Soft Reasoners over Language
  type: paper-conference
  URL: http://arxiv.org/abs/2002.05867

- id: EllisSampling2016
  author:
    - family: Ellis
      given: Kevin
    - family: Solar-Lezama
      given: Armando
    - family: Tenenbaum
      given: Josh
  citation-key: EllisSampling2016
  container-title: Advances in Neural Information Processing Systems 29
  editor:
    - family: Lee
      given: D. D.
    - family: Sugiyama
      given: M.
    - family: Luxburg
      given: U. V.
    - family: Guyon
      given: I.
    - family: Garnett
      given: R.
  issued:
    - year: 2016
  page: 1289–1297
  publisher: Curran Associates, Inc.
  title: Sampling for Bayesian Program Learning
  type: paper-conference
  URL: http://papers.nips.cc/paper/6082-sampling-for-bayesian-program-learning.pdf

- id: GarcezNeurosymbolic2020
  accessed:
    - year: 2023
      month: 1
      day: 17
  author:
    - family: Garcez
      given: Artur
      dropping-particle: d’Avila
    - family: Lamb
      given: Luis C.
  citation-key: GarcezNeurosymbolic2020
  DOI: 10.48550/arXiv.2012.05876
  issued:
    - year: 2020
      month: 12
      day: 16
  number: arXiv:2012.05876
  publisher: arXiv
  title: 'Neurosymbolic AI: The 3rd Wave'
  type: article
  URL: http://arxiv.org/abs/2012.05876

- id: GravesHybrid2016
  accessed:
    - year: 2016
      month: 10
      day: 14
  author:
    - family: Graves
      given: Alex
    - family: Wayne
      given: Greg
    - family: Reynolds
      given: Malcolm
    - family: Harley
      given: Tim
    - family: Danihelka
      given: Ivo
    - family: Grabska-Barwińska
      given: Agnieszka
    - family: Colmenarejo
      given: Sergio Gómez
    - family: Grefenstette
      given: Edward
    - family: Ramalho
      given: Tiago
    - family: Agapiou
      given: John
    - family: Badia
      given: Adrià Puigdomènech
    - family: Hermann
      given: Karl Moritz
    - family: Zwols
      given: Yori
    - family: Ostrovski
      given: Georg
    - family: Cain
      given: Adam
    - family: King
      given: Helen
    - family: Summerfield
      given: Christopher
    - family: Blunsom
      given: Phil
    - family: Kavukcuoglu
      given: Koray
    - family: Hassabis
      given: Demis
  citation-key: GravesHybrid2016
  container-title: Nature
  container-title-short: Nature
  DOI: 10.1038/nature20101
  ISSN: 0028-0836
  issued:
    - year: 2016
      month: 10
      day: 12
  language: en
  title: Hybrid computing using a neural network with dynamic external memory
  type: article-journal
  volume: advance online publication

- id: GravesNeural2014
  accessed:
    - year: 2016
      month: 10
      day: 14
  author:
    - family: Graves
      given: Alex
    - family: Wayne
      given: Greg
    - family: Danihelka
      given: Ivo
  citation-key: GravesNeural2014
  container-title: arXiv:1410.5401 [cs]
  issued:
    - year: 2014
      month: 10
      day: 20
  title: Neural Turing Machines
  type: article-journal
  URL: http://arxiv.org/abs/1410.5401

- id: GrefenstetteLearning2015
  accessed:
    - year: 2016
      month: 10
      day: 11
  author:
    - family: Grefenstette
      given: Edward
    - family: Hermann
      given: Karl Moritz
    - family: Suleyman
      given: Mustafa
    - family: Blunsom
      given: Phil
  citation-key: GrefenstetteLearning2015
  container-title: arXiv:1506.02516 [cs]
  issued:
    - year: 2015
      month: 6
      day: 8
  title: Learning to Transduce with Unbounded Memory
  type: article-journal
  URL: http://arxiv.org/abs/1506.02516

- id: GulcehreDynamic2016
  accessed:
    - year: 2016
      month: 10
      day: 14
  author:
    - family: Gulcehre
      given: Caglar
    - family: Chandar
      given: Sarath
    - family: Cho
      given: Kyunghyun
    - family: Bengio
      given: Yoshua
  citation-key: GulcehreDynamic2016
  container-title: arXiv:1607.00036 [cs]
  issued:
    - year: 2016
      month: 6
      day: 30
  title: Dynamic Neural Turing Machine with Soft and Hard Addressing Schemes
  type: article-journal
  URL: http://arxiv.org/abs/1607.00036

- id: HannunDifferentiable2020
  accessed:
    - year: 2020
      month: 10
      day: 12
  author:
    - family: Hannun
      given: Awni
    - family: Pratap
      given: Vineel
    - family: Kahn
      given: Jacob
    - family: Hsu
      given: Wei-Ning
  citation-key: HannunDifferentiable2020
  container-title: arXiv:2010.01003 [cs, stat]
  issued:
    - year: 2020
      month: 10
      day: 2
  title: Differentiable Weighted Finite-State Transducers
  type: article-journal
  URL: http://arxiv.org/abs/2010.01003

- id: IbarzGeneralist2022
  accessed:
    - year: 2023
      month: 11
      day: 16
  author:
    - family: Ibarz
      given: Borja
    - family: Kurin
      given: Vitaly
    - family: Papamakarios
      given: George
    - family: Nikiforou
      given: Kyriacos
    - family: Bennani
      given: Mehdi
    - family: Csordás
      given: Róbert
    - family: Dudzik
      given: Andrew
    - family: Bošnjak
      given: Matko
    - family: Vitvitskyi
      given: Alex
    - family: Rubanova
      given: Yulia
    - family: Deac
      given: Andreea
    - family: Bevilacqua
      given: Beatrice
    - family: Ganin
      given: Yaroslav
    - family: Blundell
      given: Charles
    - family: Veličković
      given: Petar
  citation-key: IbarzGeneralist2022
  DOI: 10.48550/arXiv.2209.11142
  issued:
    - year: 2022
      month: 12
      day: 3
  number: arXiv:2209.11142
  publisher: arXiv
  title: A Generalist Neural Algorithmic Learner
  type: article
  URL: http://arxiv.org/abs/2209.11142

- id: IkedaDecentralized1989
  accessed:
    - year: 2023
      month: 4
      day: 6
  author:
    - family: Ikeda
      given: M.
  citation-key: IkedaDecentralized1989
  collection-title: Lecture Notes in Control and Information Sciences
  container-title: >-
    Three Decades of Mathematical System Theory: A Collection of Surveys at the
    Occasion of the 50th Birthday of Jan C. Willems
  DOI: 10.1007/BFb0008464
  editor:
    - family: Nijmeijer
      given: Hendrik
    - family: Schumacher
      given: Johannes M.
  event-place: Berlin, Heidelberg
  ISBN: 978-3-540-46709-0
  issued:
    - year: 1989
  language: en
  page: 219-242
  publisher: Springer
  publisher-place: Berlin, Heidelberg
  title: Decentralized control of large scale systems
  type: chapter

- id: JaitlyNeural2015
  accessed:
    - year: 2018
      month: 4
      day: 3
  author:
    - family: Jaitly
      given: Navdeep
    - family: Sussillo
      given: David
    - family: Le
      given: Quoc V.
    - family: Vinyals
      given: Oriol
    - family: Sutskever
      given: Ilya
    - family: Bengio
      given: Samy
  citation-key: JaitlyNeural2015
  container-title: arXiv:1511.04868 [cs]
  issued:
    - year: 2015
      month: 11
      day: 16
  title: A Neural Transducer
  type: article-journal
  URL: http://arxiv.org/abs/1511.04868

- id: KaiserNeural2015
  accessed:
    - year: 2016
      month: 6
      day: 23
  author:
    - family: Kaiser
      given: Łukasz
    - family: Sutskever
      given: Ilya
  citation-key: KaiserNeural2015
  container-title: arXiv:1511.08228 [cs]
  issued:
    - year: 2015
      month: 11
      day: 25
  title: Neural GPUs Learn Algorithms
  type: article-journal
  URL: http://arxiv.org/abs/1511.08228

- id: KimNeural2022
  accessed:
    - year: 2022
      month: 3
      day: 28
  author:
    - family: Kim
      given: Jason Z.
    - family: Bassett
      given: Dani S.
  citation-key: KimNeural2022
  container-title: arXiv:2203.05032 [cond-mat, physics:nlin]
  issued:
    - year: 2022
      month: 3
      day: 9
  title: A Neural Programming Language for the Reservoir Computer
  type: article-journal
  URL: http://arxiv.org/abs/2203.05032

- id: LaiVariational2022
  accessed:
    - year: 2022
      month: 5
      day: 16
  author:
    - family: Lai
      given: Jinlin
    - family: Domke
      given: Justin
    - family: Sheldon
      given: Daniel
  citation-key: LaiVariational2022
  container-title: >-
    Proceedings of The 25th International Conference on Artificial Intelligence
    and Statistics
  event-title: International Conference on Artificial Intelligence and Statistics
  ISSN: 2640-3498
  issued:
    - year: 2022
      month: 5
      day: 3
  language: en
  page: 875-895
  publisher: PMLR
  title: Variational Marginal Particle Filters
  type: paper-conference
  URL: https://proceedings.mlr.press/v151/lai22a.html

- id: LambGraph2020
  accessed:
    - year: 2020
      month: 6
      day: 5
  author:
    - family: Lamb
      given: Luis C.
    - family: Garcez
      given: Artur
    - family: Gori
      given: Marco
    - family: Prates
      given: Marcelo
    - family: Avelar
      given: Pedro
    - family: Vardi
      given: Moshe
  citation-key: LambGraph2020
  container-title: IJCAI 2020
  issued:
    - year: 2020
      month: 5
      day: 21
  title: >-
    Graph Neural Networks Meet Neural-Symbolic Computing: A Survey and
    Perspective
  type: paper-conference
  URL: http://arxiv.org/abs/2003.00330

- id: LampleDeep2019
  accessed:
    - year: 2020
      month: 6
      day: 5
  author:
    - family: Lample
      given: Guillaume
    - family: Charton
      given: François
  citation-key: LampleDeep2019
  container-title: arXiv:1912.01412 [cs]
  issued:
    - year: 2019
      month: 12
      day: 2
  title: Deep Learning for Symbolic Mathematics
  type: article-journal
  URL: http://arxiv.org/abs/1912.01412

- id: LooksDeep2017
  author:
    - family: Looks
      given: Moshe
    - family: Herreshoff
      given: Marcello
    - family: Hutchins
      given: DeLesley
    - family: Norvig
      given: Peter
  citation-key: LooksDeep2017
  container-title: Proceedings of ICLR
  event-title: ICLR 2017
  issued:
    - year: 2017
      month: 2
      day: 7
  title: Deep Learning with Dynamic Computation Graphs
  type: paper-conference
  URL: http://arxiv.org/abs/1702.02181

- id: PerezGated2016
  accessed:
    - year: 2016
      month: 10
      day: 17
  author:
    - family: Perez
      given: Julien
    - family: Liu
      given: Fei
  citation-key: PerezGated2016
  container-title: arXiv:1610.04211 [cs, stat]
  issued:
    - year: 2016
      month: 10
      day: 13
  title: Gated End-to-End Memory Networks
  type: article-journal
  URL: http://arxiv.org/abs/1610.04211

- id: PutzkyRecurrent2017
  accessed:
    - year: 2017
      month: 9
      day: 19
  author:
    - family: Putzky
      given: Patrick
    - family: Welling
      given: Max
  citation-key: PutzkyRecurrent2017
  container-title: arXiv:1706.04008 [cs]
  issued:
    - year: 2017
      month: 6
      day: 13
  title: Recurrent Inference Machines for Solving Inverse Problems
  type: article-journal
  URL: http://arxiv.org/abs/1706.04008

- id: VelickovicNeural2021b
  accessed:
    - year: 2023
      month: 11
      day: 16
  author:
    - family: Veličković
      given: Petar
    - family: Blundell
      given: Charles
  citation-key: VelickovicNeural2021b
  container-title: Patterns
  container-title-short: Patterns
  DOI: 10.1016/j.patter.2021.100273
  ISSN: '26663899'
  issue: '7'
  issued:
    - year: 2021
      month: 7
  page: '100273'
  PMCID: PMC8276006
  PMID: '34286298'
  title: Neural Algorithmic Reasoning
  type: article-journal
  URL: http://arxiv.org/abs/2105.02761
  volume: '2'

- id: WangMambaByte2024
  accessed:
    - year: 2024
      month: 3
      day: 5
  author:
    - family: Wang
      given: Junxiong
    - family: Gangavarapu
      given: Tushaar
    - family: Yan
      given: Jing Nathan
    - family: Rush
      given: Alexander M.
  citation-key: WangMambaByte2024
  DOI: 10.48550/arXiv.2401.13660
  issued:
    - year: 2024
      month: 1
      day: 24
  number: arXiv:2401.13660
  publisher: arXiv
  title: 'MambaByte: Token-free Selective State Space Model'
  type: article
  URL: http://arxiv.org/abs/2401.13660

- id: WangStateRegularized2019
  accessed:
    - year: 2022
      month: 6
      day: 3
  author:
    - family: Wang
      given: Cheng
    - family: Niepert
      given: Mathias
  citation-key: WangStateRegularized2019
  DOI: 10.48550/arXiv.1901.08817
  issued:
    - year: 2019
      month: 5
      day: 7
  number: arXiv:1901.08817
  publisher: arXiv
  title: State-Regularized Recurrent Neural Networks
  type: article
  URL: http://arxiv.org/abs/1901.08817

- id: WangSurvey2021
  accessed:
    - year: 2022
      month: 6
      day: 3
  author:
    - family: Wang
      given: Xin
    - family: Chen
      given: Yudong
    - family: Zhu
      given: Wenwu
  citation-key: WangSurvey2021
  DOI: 10.48550/arXiv.2010.13166
  issued:
    - year: 2021
      month: 3
      day: 24
  number: arXiv:2010.13166
  publisher: arXiv
  title: A Survey on Curriculum Learning
  type: article
  URL: http://arxiv.org/abs/2010.13166

- id: WeiInnerloop2017
  accessed:
    - year: 2017
      month: 9
      day: 19
  author:
    - family: Wei
      given: Qi
    - family: Fan
      given: Kai
    - family: Carin
      given: Lawrence
    - family: Heller
      given: Katherine A.
  citation-key: WeiInnerloop2017
  container-title: arXiv:1709.01841 [cs]
  issued:
    - year: 2017
      month: 9
      day: 6
  title: An inner-loop free solution to inverse problems using deep neural networks
  type: article-journal
  URL: http://arxiv.org/abs/1709.01841

- id: WestonMemory2014
  accessed:
    - year: 2016
      month: 10
      day: 14
  author:
    - family: Weston
      given: Jason
    - family: Chopra
      given: Sumit
    - family: Bordes
      given: Antoine
  citation-key: WestonMemory2014
  container-title: arXiv:1410.3916 [cs, stat]
  issued:
    - year: 2014
      month: 10
      day: 14
  title: Memory Networks
  type: article-journal
  URL: http://arxiv.org/abs/1410.3916

- id: WuLanguage2024
  accessed:
    - year: 2024
      month: 3
      day: 5
  author:
    - family: Wu
      given: Shangda
    - family: Tan
      given: Xu
    - family: Wang
      given: Zili
    - family: Wang
      given: Rui
    - family: Li
      given: Xiaobing
    - family: Sun
      given: Maosong
  citation-key: WuLanguage2024
  DOI: 10.48550/arXiv.2402.19155
  issued:
    - year: 2024
      month: 2
      day: 29
  number: arXiv:2402.19155
  publisher: arXiv
  title: 'Beyond Language Models: Byte Models are Digital World Simulators'
  type: article
  URL: http://arxiv.org/abs/2402.19155

- id: ZhangUnveiling2022
  accessed:
    - year: 2022
      month: 6
      day: 22
  author:
    - family: Zhang
      given: Yi
    - family: Backurs
      given: Arturs
    - family: Bubeck
      given: Sébastien
    - family: Eldan
      given: Ronen
    - family: Gunasekar
      given: Suriya
    - family: Wagner
      given: Tal
  citation-key: ZhangUnveiling2022
  DOI: 10.48550/arXiv.2206.04301
  issued:
    - year: 2022
      month: 6
      day: 9
  number: arXiv:2206.04301
  publisher: arXiv
  title: 'Unveiling Transformers with LEGO: a synthetic reasoning task'
  type: article
  URL: http://arxiv.org/abs/2206.04301
...
